//<c>   Copyright 1993-2000 by Gerry J. Danen; all rights reserved.

//<t>   Change Volume Label

#include"gd_tools.h"
#include"gd_files.h"


#define pgVERS_ "V2.01"
#define pgTITL_ "Change Volume Label"
#define pgCOPR_ "1993"


void    show_help( void )
{
    logon(1);
    printf( "\n3 parameters:\n"
            "\tdrive         x:\n"
            "\tserial number nnnn-nnnn\n"
            "\tvolume label  xxxxxxxxxxx\n\n" );
    exit( BAD_EXIT );
}


void    show_label( UCHAR drive, STRING old_new )
{
    UCHAR       dLabel[12]="", dSerial[10]="", dFileSystem[9]="" ;
    UCHAR       vl_indrive[3], vl_drive[3], vl_label[13], vldat[13], vltim[10] ;
    INT32       vl_date, vl_time ;
    static      int first=TRUE ;

    if ( first )
        printf( "\nDrive %c:"
                "\t\"dir\" label  \"MID\" label  Serial #   Date       Time\n"
                "\t\t-  -      \n", drive );
    vl_indrive[0] = drive ;
    vl_indrive[1] = EOS ;
    ds_vol_label( vl_indrive, vl_drive, vl_label, &vl_date, &vl_time );
    ds_get_media_info( drive, dLabel, dSerial, dFileSystem );
    FormatDate( vl_date, vldat, 1 );
    FormatTime( vl_time, vltim, 0, 0 );
    printf( "\t%6s  %-11.11s  %-11.11s  %9s  %9s  %7s\n", old_new, vl_label, dLabel, dSerial, vldat, vltim );
    first = FALSE ;
}


void    main( int argc, char *argv[] )
{
    int         a, ret ;
    UCHAR       drv = GetDrive(), parm[128], dFileSystem[9]="FAT12",
                dLabel[12]="", dSerial[10]="", nLabel[12]="", nSerial[10]="" ;

    tt_init( SHAREWARE_VERSION, 0, pgVERS_, pgTITL_, pgCOPR_ );
    logon(0);

    //  check parameters

    if ( argc < 2 )
        show_help();

    LOOP( a, 1, argc-1, 1 )
    {
        strcpy( parm, argv[a] );
        if ( st_eq(parm, "/?") || st_eq(parm, "/h") || st_eq(parm, "/help") )
        {
            show_help();
        }
        else
        if ( strlen(parm) == 2 && parm[1] == ':' )      // drive
        {
            strupr( parm );
            drv = parm[0] ;
        }
        else
        if ( strlen(parm) == 9 && parm[4] == '-' )      // serial number
        {
            ST_CPY( nSerial, parm );
        }
        else
        {
            ST_CPY( nLabel, parm );
        }
    }

    if ( (! strlen(nLabel)) && (! strlen(nSerial)) )
    {
        show_label( drv, "" );
        exit( 0 );
    }

    if ( dr_is_remote(drv) )
    {
        printf( "Can only change local drives\n" );
        exit( 3 );
    }

    if ( dr_is_subst(drv, parm) )
    {
        printf( "Cannot change SUBSTed and ASSIGNed drives\n" );
        exit( 3 );
    }

    show_label( drv, "OLD:" );

    ret = ds_get_media_info( drv, dLabel, dSerial, dFileSystem );

    if ( strlen(nLabel) )
    {
//      printf( "ds_set_volume_label(%c,%s);\n", drv, nLabel );
        ds_set_volume_label( drv, nLabel );
    }

    if ( ! (st_eq(dFileSystem,"FAT12") || st_eq(dFileSystem,"FAT16")) )
        strcpy( dFileSystem, "FAT12" );

    ret = ds_set_media_info( drv, nLabel, nSerial, dFileSystem );
    show_label( drv, "NEW:" );
    if ( ret )
        printf( "Disk must be reformatted to set media information\n" );
}
